# Numerical Exersises Structure of Matter

In this course, we will do some numerical exercises that will complement the analytical exercises.

First of all you will need `Python`. You should have taken a python course last year, so with a bit of luck you already have it. If not you need to install it

## Windows ##
For `Windows` this can be done by downloading the binaries from the python page: https://www.python.org/downloads/windows/

## Linux ##
Python commes preinstalled on most Linux operating systems. Not there? Install it with your package manager: for me that would be

    sudo apt-get install pyhton3

## Mac ##
For some of you reading this, this command may be enough. You can run Python 3 using this command (with the 3 at the end).

    python3

If that's all you came for, no worries. Have a fun day and happy coding.

If it's not present: The you need to do a bit of `HomeBrew`. There are many recipies online for this. Here is [one](https://www.freecodecamp.org/news/python-version-on-mac-update), and here is [another](https://medium.com/marvelous-mlops/the-rightway-to-install-python-on-a-mac-f3146d9d9a32).


## SISL ##

We will  use the Python software SISL (https://sisl.readthedocs.io/en/v0.14.3/).
SISL is usually not installed from scratch in Python, but you can easily install it using, e.g. pip3 or (ana)conda.
This tutorial uses the functions of SISL 0.14.3. To ensure that you have it you can install it with pip or conda.
### With `pip` ###

    pip3 install 'sisl=0.14.3'
    
### With `conda` ###

    conda install -c conda-forge 'sisl=0.14.3'

## Jupyter Nootebooks ##

You will find jupyter-nootebooks with exercises. Just like SISL you can install the Juypyter notebook from the terminal with the command

    pip3 install notebook

Should this not work, then you can find further instructions at the jupyter website: https://jupyter.org/install

To start the notebook, you type in the terminal

    jupyter notebook <FILE TO OPEN>


You will also find the file `helper_function.py` in each of the exercise folders. This is a set of custom-made visualization functions that help us work with SISL. SISL itself also comes with its own visualizer, `SISL.viz`, which is worth [exploring](https://sisl.readthedocs.io/en/latest/api/viz/index.html#module-sisl.viz).

We will further make use of the Python packages `numpy` and `matplotlib`. These can also be installed using `pip3`. Simply type

    pip3 install numpy matplotlib
    
to install them. We will make use of `mpl_toolkits`, which should come bundled with Python. Should this not be the case, you can also install it via `pip3` as

    pip3 install basemap
    
For other ways to get it, please refer to [this reference](https://stackoverflow.com/questions/37661119/python-mpl-toolkits-installation-issue).



## `ipympl` ##
We use ipympl to be able to rotate images. It can be isntall with `pip` or `conda as`

    pip install ipympl

    conda install -c conda-forge ipympl



## Backup Notebooks in Google Colab ##

Should you run into trouble with installing e.g. SISL (or even python) on you own machine, then you might want to check out Google colab: https://colab.google/

```
Colab is a hosted Jupyter Notebook service that requires no setup to use and provides free access to computing resources, including GPUs and TPUs. Colab is especially well suited to machine learning, data science, and education.
```

In this link you can find a short video tutorial explaining how to set it up with SISL:

https://www.loom.com/share/589493149f8f4bd4836d93d5723c2bc4?sid=3998b42f-088c-4541-9300-a5237751d277